package com.tzld.piaoquan.growth.common.model.po;


import com.tzld.piaoquan.growth.common.utils.page.Page;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class GhDetailExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    protected Page page;

    public GhDetailExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    public void setPage(Page page) {
        this.page=page;
    }

    public Page getPage() {
        return page;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andGhIdIsNull() {
            addCriterion("gh_id is null");
            return (Criteria) this;
        }

        public Criteria andGhIdIsNotNull() {
            addCriterion("gh_id is not null");
            return (Criteria) this;
        }

        public Criteria andGhIdEqualTo(String value) {
            addCriterion("gh_id =", value, "ghId");
            return (Criteria) this;
        }

        public Criteria andGhIdNotEqualTo(String value) {
            addCriterion("gh_id <>", value, "ghId");
            return (Criteria) this;
        }

        public Criteria andGhIdGreaterThan(String value) {
            addCriterion("gh_id >", value, "ghId");
            return (Criteria) this;
        }

        public Criteria andGhIdGreaterThanOrEqualTo(String value) {
            addCriterion("gh_id >=", value, "ghId");
            return (Criteria) this;
        }

        public Criteria andGhIdLessThan(String value) {
            addCriterion("gh_id <", value, "ghId");
            return (Criteria) this;
        }

        public Criteria andGhIdLessThanOrEqualTo(String value) {
            addCriterion("gh_id <=", value, "ghId");
            return (Criteria) this;
        }

        public Criteria andGhIdLike(String value) {
            addCriterion("gh_id like", value, "ghId");
            return (Criteria) this;
        }

        public Criteria andGhIdNotLike(String value) {
            addCriterion("gh_id not like", value, "ghId");
            return (Criteria) this;
        }

        public Criteria andGhIdIn(List<String> values) {
            addCriterion("gh_id in", values, "ghId");
            return (Criteria) this;
        }

        public Criteria andGhIdNotIn(List<String> values) {
            addCriterion("gh_id not in", values, "ghId");
            return (Criteria) this;
        }

        public Criteria andGhIdBetween(String value1, String value2) {
            addCriterion("gh_id between", value1, value2, "ghId");
            return (Criteria) this;
        }

        public Criteria andGhIdNotBetween(String value1, String value2) {
            addCriterion("gh_id not between", value1, value2, "ghId");
            return (Criteria) this;
        }

        public Criteria andGhNameIsNull() {
            addCriterion("gh_name is null");
            return (Criteria) this;
        }

        public Criteria andGhNameIsNotNull() {
            addCriterion("gh_name is not null");
            return (Criteria) this;
        }

        public Criteria andGhNameEqualTo(String value) {
            addCriterion("gh_name =", value, "ghName");
            return (Criteria) this;
        }

        public Criteria andGhNameNotEqualTo(String value) {
            addCriterion("gh_name <>", value, "ghName");
            return (Criteria) this;
        }

        public Criteria andGhNameGreaterThan(String value) {
            addCriterion("gh_name >", value, "ghName");
            return (Criteria) this;
        }

        public Criteria andGhNameGreaterThanOrEqualTo(String value) {
            addCriterion("gh_name >=", value, "ghName");
            return (Criteria) this;
        }

        public Criteria andGhNameLessThan(String value) {
            addCriterion("gh_name <", value, "ghName");
            return (Criteria) this;
        }

        public Criteria andGhNameLessThanOrEqualTo(String value) {
            addCriterion("gh_name <=", value, "ghName");
            return (Criteria) this;
        }

        public Criteria andGhNameLike(String value) {
            addCriterion("gh_name like", value, "ghName");
            return (Criteria) this;
        }

        public Criteria andGhNameNotLike(String value) {
            addCriterion("gh_name not like", value, "ghName");
            return (Criteria) this;
        }

        public Criteria andGhNameIn(List<String> values) {
            addCriterion("gh_name in", values, "ghName");
            return (Criteria) this;
        }

        public Criteria andGhNameNotIn(List<String> values) {
            addCriterion("gh_name not in", values, "ghName");
            return (Criteria) this;
        }

        public Criteria andGhNameBetween(String value1, String value2) {
            addCriterion("gh_name between", value1, value2, "ghName");
            return (Criteria) this;
        }

        public Criteria andGhNameNotBetween(String value1, String value2) {
            addCriterion("gh_name not between", value1, value2, "ghName");
            return (Criteria) this;
        }

        public Criteria andTypeIsNull() {
            addCriterion("`type` is null");
            return (Criteria) this;
        }

        public Criteria andTypeIsNotNull() {
            addCriterion("`type` is not null");
            return (Criteria) this;
        }

        public Criteria andTypeEqualTo(Integer value) {
            addCriterion("`type` =", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeNotEqualTo(Integer value) {
            addCriterion("`type` <>", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeGreaterThan(Integer value) {
            addCriterion("`type` >", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("`type` >=", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeLessThan(Integer value) {
            addCriterion("`type` <", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeLessThanOrEqualTo(Integer value) {
            addCriterion("`type` <=", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeIn(List<Integer> values) {
            addCriterion("`type` in", values, "type");
            return (Criteria) this;
        }

        public Criteria andTypeNotIn(List<Integer> values) {
            addCriterion("`type` not in", values, "type");
            return (Criteria) this;
        }

        public Criteria andTypeBetween(Integer value1, Integer value2) {
            addCriterion("`type` between", value1, value2, "type");
            return (Criteria) this;
        }

        public Criteria andTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("`type` not between", value1, value2, "type");
            return (Criteria) this;
        }

        public Criteria andCategory1IsNull() {
            addCriterion("category1 is null");
            return (Criteria) this;
        }

        public Criteria andCategory1IsNotNull() {
            addCriterion("category1 is not null");
            return (Criteria) this;
        }

        public Criteria andCategory1EqualTo(String value) {
            addCriterion("category1 =", value, "category1");
            return (Criteria) this;
        }

        public Criteria andCategory1NotEqualTo(String value) {
            addCriterion("category1 <>", value, "category1");
            return (Criteria) this;
        }

        public Criteria andCategory1GreaterThan(String value) {
            addCriterion("category1 >", value, "category1");
            return (Criteria) this;
        }

        public Criteria andCategory1GreaterThanOrEqualTo(String value) {
            addCriterion("category1 >=", value, "category1");
            return (Criteria) this;
        }

        public Criteria andCategory1LessThan(String value) {
            addCriterion("category1 <", value, "category1");
            return (Criteria) this;
        }

        public Criteria andCategory1LessThanOrEqualTo(String value) {
            addCriterion("category1 <=", value, "category1");
            return (Criteria) this;
        }

        public Criteria andCategory1Like(String value) {
            addCriterion("category1 like", value, "category1");
            return (Criteria) this;
        }

        public Criteria andCategory1NotLike(String value) {
            addCriterion("category1 not like", value, "category1");
            return (Criteria) this;
        }

        public Criteria andCategory1In(List<String> values) {
            addCriterion("category1 in", values, "category1");
            return (Criteria) this;
        }

        public Criteria andCategory1NotIn(List<String> values) {
            addCriterion("category1 not in", values, "category1");
            return (Criteria) this;
        }

        public Criteria andCategory1Between(String value1, String value2) {
            addCriterion("category1 between", value1, value2, "category1");
            return (Criteria) this;
        }

        public Criteria andCategory1NotBetween(String value1, String value2) {
            addCriterion("category1 not between", value1, value2, "category1");
            return (Criteria) this;
        }

        public Criteria andCategory2IsNull() {
            addCriterion("category2 is null");
            return (Criteria) this;
        }

        public Criteria andCategory2IsNotNull() {
            addCriterion("category2 is not null");
            return (Criteria) this;
        }

        public Criteria andCategory2EqualTo(String value) {
            addCriterion("category2 =", value, "category2");
            return (Criteria) this;
        }

        public Criteria andCategory2NotEqualTo(String value) {
            addCriterion("category2 <>", value, "category2");
            return (Criteria) this;
        }

        public Criteria andCategory2GreaterThan(String value) {
            addCriterion("category2 >", value, "category2");
            return (Criteria) this;
        }

        public Criteria andCategory2GreaterThanOrEqualTo(String value) {
            addCriterion("category2 >=", value, "category2");
            return (Criteria) this;
        }

        public Criteria andCategory2LessThan(String value) {
            addCriterion("category2 <", value, "category2");
            return (Criteria) this;
        }

        public Criteria andCategory2LessThanOrEqualTo(String value) {
            addCriterion("category2 <=", value, "category2");
            return (Criteria) this;
        }

        public Criteria andCategory2Like(String value) {
            addCriterion("category2 like", value, "category2");
            return (Criteria) this;
        }

        public Criteria andCategory2NotLike(String value) {
            addCriterion("category2 not like", value, "category2");
            return (Criteria) this;
        }

        public Criteria andCategory2In(List<String> values) {
            addCriterion("category2 in", values, "category2");
            return (Criteria) this;
        }

        public Criteria andCategory2NotIn(List<String> values) {
            addCriterion("category2 not in", values, "category2");
            return (Criteria) this;
        }

        public Criteria andCategory2Between(String value1, String value2) {
            addCriterion("category2 between", value1, value2, "category2");
            return (Criteria) this;
        }

        public Criteria andCategory2NotBetween(String value1, String value2) {
            addCriterion("category2 not between", value1, value2, "category2");
            return (Criteria) this;
        }

        public Criteria andIsDeleteIsNull() {
            addCriterion("is_delete is null");
            return (Criteria) this;
        }

        public Criteria andIsDeleteIsNotNull() {
            addCriterion("is_delete is not null");
            return (Criteria) this;
        }

        public Criteria andIsDeleteEqualTo(Integer value) {
            addCriterion("is_delete =", value, "isDelete");
            return (Criteria) this;
        }

        public Criteria andIsDeleteNotEqualTo(Integer value) {
            addCriterion("is_delete <>", value, "isDelete");
            return (Criteria) this;
        }

        public Criteria andIsDeleteGreaterThan(Integer value) {
            addCriterion("is_delete >", value, "isDelete");
            return (Criteria) this;
        }

        public Criteria andIsDeleteGreaterThanOrEqualTo(Integer value) {
            addCriterion("is_delete >=", value, "isDelete");
            return (Criteria) this;
        }

        public Criteria andIsDeleteLessThan(Integer value) {
            addCriterion("is_delete <", value, "isDelete");
            return (Criteria) this;
        }

        public Criteria andIsDeleteLessThanOrEqualTo(Integer value) {
            addCriterion("is_delete <=", value, "isDelete");
            return (Criteria) this;
        }

        public Criteria andIsDeleteIn(List<Integer> values) {
            addCriterion("is_delete in", values, "isDelete");
            return (Criteria) this;
        }

        public Criteria andIsDeleteNotIn(List<Integer> values) {
            addCriterion("is_delete not in", values, "isDelete");
            return (Criteria) this;
        }

        public Criteria andIsDeleteBetween(Integer value1, Integer value2) {
            addCriterion("is_delete between", value1, value2, "isDelete");
            return (Criteria) this;
        }

        public Criteria andIsDeleteNotBetween(Integer value1, Integer value2) {
            addCriterion("is_delete not between", value1, value2, "isDelete");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andChannelIsNull() {
            addCriterion("channel is null");
            return (Criteria) this;
        }

        public Criteria andChannelIsNotNull() {
            addCriterion("channel is not null");
            return (Criteria) this;
        }

        public Criteria andChannelEqualTo(String value) {
            addCriterion("channel =", value, "channel");
            return (Criteria) this;
        }

        public Criteria andChannelNotEqualTo(String value) {
            addCriterion("channel <>", value, "channel");
            return (Criteria) this;
        }

        public Criteria andChannelGreaterThan(String value) {
            addCriterion("channel >", value, "channel");
            return (Criteria) this;
        }

        public Criteria andChannelGreaterThanOrEqualTo(String value) {
            addCriterion("channel >=", value, "channel");
            return (Criteria) this;
        }

        public Criteria andChannelLessThan(String value) {
            addCriterion("channel <", value, "channel");
            return (Criteria) this;
        }

        public Criteria andChannelLessThanOrEqualTo(String value) {
            addCriterion("channel <=", value, "channel");
            return (Criteria) this;
        }

        public Criteria andChannelLike(String value) {
            addCriterion("channel like", value, "channel");
            return (Criteria) this;
        }

        public Criteria andChannelNotLike(String value) {
            addCriterion("channel not like", value, "channel");
            return (Criteria) this;
        }

        public Criteria andChannelIn(List<String> values) {
            addCriterion("channel in", values, "channel");
            return (Criteria) this;
        }

        public Criteria andChannelNotIn(List<String> values) {
            addCriterion("channel not in", values, "channel");
            return (Criteria) this;
        }

        public Criteria andChannelBetween(String value1, String value2) {
            addCriterion("channel between", value1, value2, "channel");
            return (Criteria) this;
        }

        public Criteria andChannelNotBetween(String value1, String value2) {
            addCriterion("channel not between", value1, value2, "channel");
            return (Criteria) this;
        }

        public Criteria andVideoIdsIsNull() {
            addCriterion("video_ids is null");
            return (Criteria) this;
        }

        public Criteria andVideoIdsIsNotNull() {
            addCriterion("video_ids is not null");
            return (Criteria) this;
        }

        public Criteria andVideoIdsEqualTo(String value) {
            addCriterion("video_ids =", value, "videoIds");
            return (Criteria) this;
        }

        public Criteria andVideoIdsNotEqualTo(String value) {
            addCriterion("video_ids <>", value, "videoIds");
            return (Criteria) this;
        }

        public Criteria andVideoIdsGreaterThan(String value) {
            addCriterion("video_ids >", value, "videoIds");
            return (Criteria) this;
        }

        public Criteria andVideoIdsGreaterThanOrEqualTo(String value) {
            addCriterion("video_ids >=", value, "videoIds");
            return (Criteria) this;
        }

        public Criteria andVideoIdsLessThan(String value) {
            addCriterion("video_ids <", value, "videoIds");
            return (Criteria) this;
        }

        public Criteria andVideoIdsLessThanOrEqualTo(String value) {
            addCriterion("video_ids <=", value, "videoIds");
            return (Criteria) this;
        }

        public Criteria andVideoIdsLike(String value) {
            addCriterion("video_ids like", value, "videoIds");
            return (Criteria) this;
        }

        public Criteria andVideoIdsNotLike(String value) {
            addCriterion("video_ids not like", value, "videoIds");
            return (Criteria) this;
        }

        public Criteria andVideoIdsIn(List<String> values) {
            addCriterion("video_ids in", values, "videoIds");
            return (Criteria) this;
        }

        public Criteria andVideoIdsNotIn(List<String> values) {
            addCriterion("video_ids not in", values, "videoIds");
            return (Criteria) this;
        }

        public Criteria andVideoIdsBetween(String value1, String value2) {
            addCriterion("video_ids between", value1, value2, "videoIds");
            return (Criteria) this;
        }

        public Criteria andVideoIdsNotBetween(String value1, String value2) {
            addCriterion("video_ids not between", value1, value2, "videoIds");
            return (Criteria) this;
        }

        public Criteria andStrategyStatusIsNull() {
            addCriterion("strategy_status is null");
            return (Criteria) this;
        }

        public Criteria andStrategyStatusIsNotNull() {
            addCriterion("strategy_status is not null");
            return (Criteria) this;
        }

        public Criteria andStrategyStatusEqualTo(Integer value) {
            addCriterion("strategy_status =", value, "strategyStatus");
            return (Criteria) this;
        }

        public Criteria andStrategyStatusNotEqualTo(Integer value) {
            addCriterion("strategy_status <>", value, "strategyStatus");
            return (Criteria) this;
        }

        public Criteria andStrategyStatusGreaterThan(Integer value) {
            addCriterion("strategy_status >", value, "strategyStatus");
            return (Criteria) this;
        }

        public Criteria andStrategyStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("strategy_status >=", value, "strategyStatus");
            return (Criteria) this;
        }

        public Criteria andStrategyStatusLessThan(Integer value) {
            addCriterion("strategy_status <", value, "strategyStatus");
            return (Criteria) this;
        }

        public Criteria andStrategyStatusLessThanOrEqualTo(Integer value) {
            addCriterion("strategy_status <=", value, "strategyStatus");
            return (Criteria) this;
        }

        public Criteria andStrategyStatusIn(List<Integer> values) {
            addCriterion("strategy_status in", values, "strategyStatus");
            return (Criteria) this;
        }

        public Criteria andStrategyStatusNotIn(List<Integer> values) {
            addCriterion("strategy_status not in", values, "strategyStatus");
            return (Criteria) this;
        }

        public Criteria andStrategyStatusBetween(Integer value1, Integer value2) {
            addCriterion("strategy_status between", value1, value2, "strategyStatus");
            return (Criteria) this;
        }

        public Criteria andStrategyStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("strategy_status not between", value1, value2, "strategyStatus");
            return (Criteria) this;
        }

        public Criteria andAutoreplySendMinigramNumIsNull() {
            addCriterion("autoreply_send_minigram_num is null");
            return (Criteria) this;
        }

        public Criteria andAutoreplySendMinigramNumIsNotNull() {
            addCriterion("autoreply_send_minigram_num is not null");
            return (Criteria) this;
        }

        public Criteria andAutoreplySendMinigramNumEqualTo(Integer value) {
            addCriterion("autoreply_send_minigram_num =", value, "autoreplySendMinigramNum");
            return (Criteria) this;
        }

        public Criteria andAutoreplySendMinigramNumNotEqualTo(Integer value) {
            addCriterion("autoreply_send_minigram_num <>", value, "autoreplySendMinigramNum");
            return (Criteria) this;
        }

        public Criteria andAutoreplySendMinigramNumGreaterThan(Integer value) {
            addCriterion("autoreply_send_minigram_num >", value, "autoreplySendMinigramNum");
            return (Criteria) this;
        }

        public Criteria andAutoreplySendMinigramNumGreaterThanOrEqualTo(Integer value) {
            addCriterion("autoreply_send_minigram_num >=", value, "autoreplySendMinigramNum");
            return (Criteria) this;
        }

        public Criteria andAutoreplySendMinigramNumLessThan(Integer value) {
            addCriterion("autoreply_send_minigram_num <", value, "autoreplySendMinigramNum");
            return (Criteria) this;
        }

        public Criteria andAutoreplySendMinigramNumLessThanOrEqualTo(Integer value) {
            addCriterion("autoreply_send_minigram_num <=", value, "autoreplySendMinigramNum");
            return (Criteria) this;
        }

        public Criteria andAutoreplySendMinigramNumIn(List<Integer> values) {
            addCriterion("autoreply_send_minigram_num in", values, "autoreplySendMinigramNum");
            return (Criteria) this;
        }

        public Criteria andAutoreplySendMinigramNumNotIn(List<Integer> values) {
            addCriterion("autoreply_send_minigram_num not in", values, "autoreplySendMinigramNum");
            return (Criteria) this;
        }

        public Criteria andAutoreplySendMinigramNumBetween(Integer value1, Integer value2) {
            addCriterion("autoreply_send_minigram_num between", value1, value2, "autoreplySendMinigramNum");
            return (Criteria) this;
        }

        public Criteria andAutoreplySendMinigramNumNotBetween(Integer value1, Integer value2) {
            addCriterion("autoreply_send_minigram_num not between", value1, value2, "autoreplySendMinigramNum");
            return (Criteria) this;
        }

        public Criteria andRateIsNull() {
            addCriterion("rate is null");
            return (Criteria) this;
        }

        public Criteria andRateIsNotNull() {
            addCriterion("rate is not null");
            return (Criteria) this;
        }

        public Criteria andRateEqualTo(String value) {
            addCriterion("rate =", value, "rate");
            return (Criteria) this;
        }

        public Criteria andRateNotEqualTo(String value) {
            addCriterion("rate <>", value, "rate");
            return (Criteria) this;
        }

        public Criteria andRateGreaterThan(String value) {
            addCriterion("rate >", value, "rate");
            return (Criteria) this;
        }

        public Criteria andRateGreaterThanOrEqualTo(String value) {
            addCriterion("rate >=", value, "rate");
            return (Criteria) this;
        }

        public Criteria andRateLessThan(String value) {
            addCriterion("rate <", value, "rate");
            return (Criteria) this;
        }

        public Criteria andRateLessThanOrEqualTo(String value) {
            addCriterion("rate <=", value, "rate");
            return (Criteria) this;
        }

        public Criteria andRateLike(String value) {
            addCriterion("rate like", value, "rate");
            return (Criteria) this;
        }

        public Criteria andRateNotLike(String value) {
            addCriterion("rate not like", value, "rate");
            return (Criteria) this;
        }

        public Criteria andRateIn(List<String> values) {
            addCriterion("rate in", values, "rate");
            return (Criteria) this;
        }

        public Criteria andRateNotIn(List<String> values) {
            addCriterion("rate not in", values, "rate");
            return (Criteria) this;
        }

        public Criteria andRateBetween(String value1, String value2) {
            addCriterion("rate between", value1, value2, "rate");
            return (Criteria) this;
        }

        public Criteria andRateNotBetween(String value1, String value2) {
            addCriterion("rate not between", value1, value2, "rate");
            return (Criteria) this;
        }

        public Criteria andContentDetailIsNull() {
            addCriterion("content_detail is null");
            return (Criteria) this;
        }

        public Criteria andContentDetailIsNotNull() {
            addCriterion("content_detail is not null");
            return (Criteria) this;
        }

        public Criteria andContentDetailEqualTo(String value) {
            addCriterion("content_detail =", value, "contentDetail");
            return (Criteria) this;
        }

        public Criteria andContentDetailNotEqualTo(String value) {
            addCriterion("content_detail <>", value, "contentDetail");
            return (Criteria) this;
        }

        public Criteria andContentDetailGreaterThan(String value) {
            addCriterion("content_detail >", value, "contentDetail");
            return (Criteria) this;
        }

        public Criteria andContentDetailGreaterThanOrEqualTo(String value) {
            addCriterion("content_detail >=", value, "contentDetail");
            return (Criteria) this;
        }

        public Criteria andContentDetailLessThan(String value) {
            addCriterion("content_detail <", value, "contentDetail");
            return (Criteria) this;
        }

        public Criteria andContentDetailLessThanOrEqualTo(String value) {
            addCriterion("content_detail <=", value, "contentDetail");
            return (Criteria) this;
        }

        public Criteria andContentDetailLike(String value) {
            addCriterion("content_detail like", value, "contentDetail");
            return (Criteria) this;
        }

        public Criteria andContentDetailNotLike(String value) {
            addCriterion("content_detail not like", value, "contentDetail");
            return (Criteria) this;
        }

        public Criteria andContentDetailIn(List<String> values) {
            addCriterion("content_detail in", values, "contentDetail");
            return (Criteria) this;
        }

        public Criteria andContentDetailNotIn(List<String> values) {
            addCriterion("content_detail not in", values, "contentDetail");
            return (Criteria) this;
        }

        public Criteria andContentDetailBetween(String value1, String value2) {
            addCriterion("content_detail between", value1, value2, "contentDetail");
            return (Criteria) this;
        }

        public Criteria andContentDetailNotBetween(String value1, String value2) {
            addCriterion("content_detail not between", value1, value2, "contentDetail");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}